﻿using System;
using Windows.Storage;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    /// 샘플 페이지 1
    /// </summary>
    public sealed partial class SamplePage01 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 메인 페이지
        /// </summary>
        private MainPage mainPage = MainPage.CurrentPage;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SamplePage01()

        /// <summary>
        /// 생성자
        /// </summary>
        public SamplePage01()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 파일 생성 버튼 클릭시 처리하기 - createFileButton_Click(sender, e)

        /// <summary>
        /// 파일 생성 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void createFileButton_Click(object sender, RoutedEventArgs e)
        {
            StorageFolder storageFolder = await KnownFolders.GetFolderForUserAsync(null /* 현재 사용자 */, KnownFolderId.PicturesLibrary);

            try
            {
                this.mainPage.SampleStorageFile = await storageFolder.CreateFileAsync(MainPage.FileName, CreationCollisionOption.ReplaceExisting);

                this.mainPage.ShowStatusMessage
                (
                    $"'{mainPage.SampleStorageFile.Name}' 파일을 생성했습니다.",
                    NotifyType.StatusMessage
                );
            }
            catch(Exception exception)
            {
                this.mainPage.ShowStatusMessage
                (
                    $"'{MainPage.FileName}' 파일 생성시 에러가 발생했습니다 : {exception.Message}",
                    NotifyType.ErrorMessage
                );
            }
        }

        #endregion
    }
}