﻿using System;
using System.IO;
using Windows.Storage;
using Windows.Storage.Pickers;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;
using Windows.UI.Xaml.Navigation;

namespace TestProject
{
    /// <summary>
    /// 샘플 페이지 9
    /// </summary>
    public sealed partial class SamplePage09 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 메인 페이지
        /// </summary>
        private MainPage mainPage = MainPage.CurrentPage;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SamplePage09()

        /// <summary>
        /// 생성자
        /// </summary>
        public SamplePage09()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 탐색되는 경우 처리하기 - OnNavigatedTo(e)

        /// <summary>
        /// 탐색되는 경우 처리하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            this.mainPage.ValidateFile();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 파일 비교 버튼 클릭시 처리하기 - compareFileButton_Click(sender, e)

        /// <summary>
        /// 파일 비교 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void compareFileButton_Click(object sender, RoutedEventArgs e)
        {
            StorageFile sourceStorageFile = this.mainPage.SampleStorageFile;

            if(sourceStorageFile != null)
            {
                FileOpenPicker fileOpenPicker = new FileOpenPicker();

                fileOpenPicker.SuggestedStartLocation = PickerLocationId.PicturesLibrary;

                fileOpenPicker.FileTypeFilter.Add("*");

                StorageFile targetStorageFile = await fileOpenPicker.PickSingleFileAsync();

                if(targetStorageFile != null)
                {
                    try
                    {
                        if(sourceStorageFile.IsEqual(targetStorageFile))
                        {
                            this.mainPage.ShowStatusMessage("파일들이 같습니다.", NotifyType.StatusMessage);
                        }
                        else
                        {
                            this.mainPage.ShowStatusMessage("파일들이 같지 않습니다.", NotifyType.StatusMessage);
                        }
                    }
                    catch(FileNotFoundException)
                    {
                        this.mainPage.ShowFileNotFoundStatusMessage();
                    }
                }
                else
                {
                    this.mainPage.ShowStatusMessage("작업이 취소되었습니다.", NotifyType.StatusMessage);
                }
            }
            else
            {
                this.mainPage.ShowFileNotFoundStatusMessage();
            }
        }

        #endregion
    }
}