﻿using System;
using Windows.Storage;
using Windows.UI.Xaml;
using Windows.UI.Xaml.Controls;

namespace TestProject
{
    /// <summary>
    /// 샘플 페이지 11
    /// </summary>
    public sealed partial class SamplePage11 : Page
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 메인 페이지
        /// </summary>
        private MainPage mainPage = MainPage.CurrentPage;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SamplePage11()

        /// <summary>
        /// 생성자
        /// </summary>
        public SamplePage11()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 파일 가져오기 버튼 클릭시 처리하기 - getFileButton_Click(sender, e)

        /// <summary>
        /// 파일 가져오기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void getFileButton_Click(object sender, RoutedEventArgs e)
        {
            StorageFolder storageFolder = await KnownFolders.GetFolderForUserAsync(null /* 현재 사용자 */, KnownFolderId.PicturesLibrary);

            StorageFile storageFile = await storageFolder.TryGetItemAsync("sample.dat") as StorageFile;

            if(storageFile != null)
            {
                this.mainPage.ShowStatusMessage($"작업 결과 : {storageFile.Name}", NotifyType.StatusMessage);
            }
            else
            {
                this.mainPage.ShowStatusMessage("작업 결과 : null", NotifyType.StatusMessage);
            }
        }

        #endregion
    }
}